# *Chef server* 的安装与配置

*Chef 提供了三种方案搭建 `Chef server`，这里只介绍 `Standalone` 方案*

## 软硬件要求

- 内存最少4G
- 其他要求请参照 [https://docs.chef.io/install_server_pre.html](https://docs.chef.io/install_server_pre.html)


## 安装包下载

安装包可从 [https://downloads.chef.io/chef-server/](https://downloads.chef.io/chef-server/)下载


## 安装

以下步骤假设安装包保存在 `/tmp/` 目录

- For Red Hat Enterprise Linux and CentOS:
  ```bash
  sudo rpm -Uvh /tmp/chef-server-core-<version>.rpm
  ```

- For Ubuntu:
  ```bash
  sudo dpkg -i /tmp/chef-server-core-<version>.deb
  ```

## 配置

#### 配置 Chef server

```bash
sudo chef-server-ctl reconfigure
```

#### 创建 Chef server 管理员

```bash
sudo chef-server-ctl user-create USER_NAME FIRST_NAME LAST_NAME EMAIL 'PASSWORD' --filename FILE_NAME
```
执行以上命令会生成管理员私钥，参数 `--filename` 为指定私钥存放路径。

例如:
```bash
sudo chef-server-ctl user-create janedoe Jane Doe janed@example.com 'abc123' --filename /path/to/janedoe.pem
```

#### 创建组织

```bash
sudo chef-server-ctl org-create short_name 'full_organization_name' --association_user user_name --filename ORGANIZATION-validator.pem
```
组织名称 `short_name` 长度范围为1到255，必须以小写字母或数字开头，其余可为小写字母、数字、英文中划线 `-` 和英文下划线 `_`。例如: `4thcoffee`.

组织全名 `full_organization_name` 长度范围为1到1023，必须以非空字符开头。例如: `'Fourth Coffee, Inc.'`.

参数 `--association_user` 指定 `user_name` 拥有 `admins` 群组权限。

执行以上命令会生成组织私钥，参数 `--filename` 为指定私钥存放路径。

例如:
```bash
sudo chef-server-ctl org-create 4thcoffee 'Fourth Coffee, Inc.' --association_user janedoe --filename /path/to/4thcoffee-validator.pem
```

#### 配置管理网站 (Chef Manage)

On the Chef server, run:
```bash
sudo chef-server-ctl install chef-manage
```

then:
```bash
sudo chef-server-ctl reconfigure
```

and then:
```bash
sudo chef-manage-ctl reconfigure
# 这一步会显示许可证，需接受才可使用
```

## 结语

成功安装和配置 `Chef server` 后，可以按照 [这个链接](https://docs.chef.io/chefdk_setup.html) 搭建 [chef repo](https://docs.chef.io/chef_repo.html)